/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package converter;

import categorization.Advertisement;
import java.net.URI;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlAttribute;
import javax.ws.rs.core.UriBuilder;
import javax.persistence.EntityManager;

/**
 *
 * @author pico
 */

@XmlRootElement(name = "advertisement")
public class AdvertisementConverter {
    private Advertisement entity;
    private URI uri;
    private int expandLevel;
  
    /** Creates a new instance of AdvertisementConverter */
    public AdvertisementConverter() {
        entity = new Advertisement();
    }

    /**
     * Creates a new instance of AdvertisementConverter.
     *
     * @param entity associated entity
     * @param uri associated uri
     * @param expandLevel indicates the number of levels the entity graph should be expanded@param isUriExtendable indicates whether the uri can be extended
     */
    public AdvertisementConverter(Advertisement entity, URI uri, int expandLevel, boolean isUriExtendable) {
        this.entity = entity;
        this.uri = (isUriExtendable) ? UriBuilder.fromUri(uri).path(entity.getAdid() + "/").build() : uri;
        this.expandLevel = expandLevel;
    }

    /**
     * Creates a new instance of AdvertisementConverter.
     *
     * @param entity associated entity
     * @param uri associated uri
     * @param expandLevel indicates the number of levels the entity graph should be expanded
     */
    public AdvertisementConverter(Advertisement entity, URI uri, int expandLevel) {
        this(entity, uri, expandLevel, false);
    }

    /**
     * Getter for adid.
     *
     * @return value for adid
     */
    @XmlElement
    public Integer getAdid() {
        return (expandLevel > 0) ? entity.getAdid() : null;
    }

    /**
     * Setter for adid.
     *
     * @param value the value to set
     */
    public void setAdid(Integer value) {
        entity.setAdid(value);
    }

    /**
     * Getter for shortDisc.
     *
     * @return value for shortDisc
     */
    @XmlElement
    public String getShortDisc() {
        return (expandLevel > 0) ? entity.getShortDisc() : null;
    }

    /**
     * Setter for shortDisc.
     *
     * @param value the value to set
     */
    public void setShortDisc(String value) {
        entity.setShortDisc(value);
    }

    /**
     * Getter for category.
     *
     * @return value for category
     */
    @XmlElement
    public String getCategory() {
        return (expandLevel > 0) ? entity.getCategory() : null;
    }

    /**
     * Setter for category.
     *
     * @param value the value to set
     */
    public void setCategory(String value) {
        entity.setCategory(value);
    }

    /**
     * Getter for longDisc.
     *
     * @return value for longDisc
     */
    @XmlElement
    public String getLongDisc() {
        return (expandLevel > 0) ? entity.getLongDisc() : null;
    }

    /**
     * Setter for longDisc.
     *
     * @param value the value to set
     */
    public void setLongDisc(String value) {
        entity.setLongDisc(value);
    }

    /**
     * Getter for type.
     *
     * @return value for type
     */
    @XmlElement
    public String getType() {
        return (expandLevel > 0) ? entity.getType() : null;
    }

    /**
     * Setter for type.
     *
     * @param value the value to set
     */
    public void setType(String value) {
        entity.setType(value);
    }

    /**
     * Getter for price.
     *
     * @return value for price
     */
    @XmlElement
    public Integer getPrice() {
        return (expandLevel > 0) ? entity.getPrice() : null;
    }

    /**
     * Setter for price.
     *
     * @param value the value to set
     */
    public void setPrice(Integer value) {
        entity.setPrice(value);
    }

    /**
     * Getter for image.
     *
     * @return value for image
     */
    @XmlElement
    public String getImage() {
        return (expandLevel > 0) ? entity.getImage() : null;
    }

    /**
     * Setter for image.
     *
     * @param value the value to set
     */
    public void setImage(String value) {
        entity.setImage(value);
    }

    /**
     * Getter for contact.
     *
     * @return value for contact
     */
    @XmlElement
    public String getContact() {
        return (expandLevel > 0) ? entity.getContact() : null;
    }

    /**
     * Setter for contact.
     *
     * @param value the value to set
     */
    public void setContact(String value) {
        entity.setContact(value);
    }

    /**
     * Getter for location.
     *
     * @return value for location
     */
    @XmlElement
    public String getLocation() {
        return (expandLevel > 0) ? entity.getLocation() : null;
    }

    /**
     * Setter for location.
     *
     * @param value the value to set
     */
    public void setLocation(String value) {
        entity.setLocation(value);
    }

    /**
     * Getter for day.
     *
     * @return value for day
     */
    @XmlElement
    public Integer getDay() {
        return (expandLevel > 0) ? entity.getDay() : null;
    }

    /**
     * Setter for day.
     *
     * @param value the value to set
     */
    public void setDay(Integer value) {
        entity.setDay(value);
    }

    /**
     * Returns the URI associated with this converter.
     *
     * @return the uri
     */
    @XmlAttribute
    public URI getUri() {
        return uri;
    }

    /**
     * Sets the URI for this reference converter.
     *
     */
    public void setUri(URI uri) {
        this.uri = uri;
    }

    /**
     * Returns the Advertisement entity.
     *
     * @return an entity
     */
    @XmlTransient
    public Advertisement getEntity() {
        if (entity.getAdid() == null) {
            AdvertisementConverter converter = UriResolver.getInstance().resolve(AdvertisementConverter.class, uri);
            if (converter != null) {
                entity = converter.getEntity();
            }
        }
        return entity;
    }

    /**
     * Returns the resolved Advertisement entity.
     *
     * @return an resolved entity
     */
    public Advertisement resolveEntity(EntityManager em) {
        return entity;
    }
}
