/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package converter;

import categorization.Advertisement;
import java.net.URI;
import java.util.Collection;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlAttribute;
import java.util.ArrayList;

/**
 *
 * @author pico
 */

@XmlRootElement(name = "advertisements")
public class AdvertisementsConverter {
    private Collection<Advertisement> entities;
    private Collection<AdvertisementConverter> items;
    private URI uri;
    private int expandLevel;
  
    /** Creates a new instance of AdvertisementsConverter */
    public AdvertisementsConverter() {
    }

    /**
     * Creates a new instance of AdvertisementsConverter.
     *
     * @param entities associated entities
     * @param uri associated uri
     * @param expandLevel indicates the number of levels the entity graph should be expanded
     */
    public AdvertisementsConverter(Collection<Advertisement> entities, URI uri, int expandLevel) {
        this.entities = entities;
        this.uri = uri;
        this.expandLevel = expandLevel;
        getAdvertisement();
    }

    /**
     * Returns a collection of AdvertisementConverter.
     *
     * @return a collection of AdvertisementConverter
     */
    @XmlElement
    public Collection<AdvertisementConverter> getAdvertisement() {
        if (items == null) {
            items = new ArrayList<AdvertisementConverter>();
        }
        if (entities != null) {
            items.clear();
            for (Advertisement entity : entities) {
                items.add(new AdvertisementConverter(entity, uri, expandLevel, true));
            }
        }
        return items;
    }

    /**
     * Sets a collection of AdvertisementConverter.
     *
     * @param a collection of AdvertisementConverter to set
     */
    public void setAdvertisement(Collection<AdvertisementConverter> items) {
        this.items = items;
    }

    /**
     * Returns the URI associated with this converter.
     *
     * @return the uri
     */
    @XmlAttribute
    public URI getUri() {
        return uri;
    }

    /**
     * Returns a collection Advertisement entities.
     *
     * @return a collection of Advertisement entities
     */
    @XmlTransient
    public Collection<Advertisement> getEntities() {
        entities = new ArrayList<Advertisement>();
        if (items != null) {
            for (AdvertisementConverter item : items) {
                entities.add(item.getEntity());
            }
        }
        return entities;
    }
}
