/*
* Support js for Advertisement
*/

var useWrapAdvertisement = true;

function Advertisement(uri_) {
    this.Advertisement(uri_, false);
}

function Advertisement(uri_, initialized_) {
    this.uri = uri_;
    this.adid = '';
    this.shortDisc = '';
    this.category = '';
    this.longDisc = '';
    this.type = '';
    this.price = '';
    this.image = '';
    this.contact = '';
    this.location = '';
    this.day = '';

    this.initialized = initialized_;
}

Advertisement.prototype = {

   getUri : function() {
      return this.uri;
   },

   getAdid : function() {
      if(!this.initialized)
         this.init();
      return this.adid;
   },

   setAdid : function(adid_) {
      this.adid = adid_;
   },

   getShortDisc : function() {
      if(!this.initialized)
         this.init();
      return this.shortDisc;
   },

   setShortDisc : function(shortDisc_) {
      this.shortDisc = shortDisc_;
   },

   getCategory : function() {
      if(!this.initialized)
         this.init();
      return this.category;
   },

   setCategory : function(category_) {
      this.category = category_;
   },

   getLongDisc : function() {
      if(!this.initialized)
         this.init();
      return this.longDisc;
   },

   setLongDisc : function(longDisc_) {
      this.longDisc = longDisc_;
   },

   getType : function() {
      if(!this.initialized)
         this.init();
      return this.type;
   },

   setType : function(type_) {
      this.type = type_;
   },

   getPrice : function() {
      if(!this.initialized)
         this.init();
      return this.price;
   },

   setPrice : function(price_) {
      this.price = price_;
   },

   getImage : function() {
      if(!this.initialized)
         this.init();
      return this.image;
   },

   setImage : function(image_) {
      this.image = image_;
   },

   getContact : function() {
      if(!this.initialized)
         this.init();
      return this.contact;
   },

   setContact : function(contact_) {
      this.contact = contact_;
   },

   getLocation : function() {
      if(!this.initialized)
         this.init();
      return this.location;
   },

   setLocation : function(location_) {
      this.location = location_;
   },

   getDay : function() {
      if(!this.initialized)
         this.init();
      return this.day;
   },

   setDay : function(day_) {
      this.day = day_;
   },



   init : function() {
      var remote = new AdvertisementRemote(this.uri);
      var c = remote.getJson_();
      if(c != -1) {
         var myObj = eval('(' +c+')');
         var advertisement = myObj.advertisement;
         if(advertisement == null || advertisement == undefined || advertisement['@uri'] == undefined) {
            advertisement = myObj;
            useWrapAdvertisement = false;
         }
         this.uri = advertisement['@uri'];
         this.adid = this.findValue(this.adid, advertisement['adid']);
         this.shortDisc = this.findValue(this.shortDisc, advertisement['shortDisc']);
         this.category = this.findValue(this.category, advertisement['category']);
         this.longDisc = this.findValue(this.longDisc, advertisement['longDisc']);
         this.type = this.findValue(this.type, advertisement['type']);
         this.price = this.findValue(this.price, advertisement['price']);
         this.image = this.findValue(this.image, advertisement['image']);
         this.contact = this.findValue(this.contact, advertisement['contact']);
         this.location = this.findValue(this.location, advertisement['location']);
         this.day = this.findValue(this.day, advertisement['day']);

         this.initialized = true;
      }
   },

   findValue : function(field, value) {
      if(value == undefined)
          return field;
      else
         return value;
   },

   flush : function() {
      var remote = new AdvertisementRemote(this.uri);
      if(useWrapAdvertisement)
         return remote.putJson_('{'+this.toString()+'}');
      else
         return remote.putJson_(this.toString());
   },

   delete_ : function() {
      var remote = new AdvertisementRemote(this.uri);
      return remote.deleteJson_();
   },

   toString : function() {
      if(!this.initialized)
         this.init();
      var myObj = 
         '{'+
         '"@uri":"'+this.uri+'"'+
                  ', "adid":"'+this.adid+'"'+
         ', "shortDisc":"'+this.shortDisc+'"'+
         ', "category":"'+this.category+'"'+
         ', "longDisc":"'+this.longDisc+'"'+
         ', "type":"'+this.type+'"'+
         ', "price":"'+this.price+'"'+
         ', "image":"'+this.image+'"'+
         ', "contact":"'+this.contact+'"'+
         ', "location":"'+this.location+'"'+
         ', "day":"'+this.day+'"'+

         '}';
      if(useWrapAdvertisement) {
          myObj = '"advertisement":'+myObj;
      }
      return myObj;
   },

   getFields : function() {
      var fields = [];
         fields.push('adid');
         fields.push('shortDisc');
         fields.push('category');
         fields.push('longDisc');
         fields.push('type');
         fields.push('price');
         fields.push('image');
         fields.push('contact');
         fields.push('location');
         fields.push('day');

      return fields;
   }

}

function AdvertisementRemote(uri_) {
    this.uri = uri_+'?expandLevel=1';
}

AdvertisementRemote.prototype = {

/* Default getJson_() method used by init() method. Do not remove. */
   getJson_ : function() {
      return rjsSupport.get(this.uri, 'application/json');
   },
/* Default putJson_() method used by flush() method. Do not remove. */
   putJson_ : function(content) {
      return rjsSupport.put(this.uri, 'application/json', content);
   },
/* Default deleteJson_() method used by delete_() method. Do not remove. */
   deleteJson_ : function() {
      return rjsSupport.delete_(this.uri);
   }
   ,
   getGoogleMapXml : function() {
      return rjsSupport.get(this.uri, 'application/xml');
   },

   getGoogleMapHtml : function() {
      return rjsSupport.get(this.uri, 'text/html');
   },

   getXml : function() {
      return rjsSupport.get(this.uri, 'application/xml');
   },

   getJson : function() {
      return rjsSupport.get(this.uri, 'application/json');
   },

   putXml : function(content) {
      return rjsSupport.put(this.uri, 'application/xml', content);
   },

   putJson : function(content) {
      return rjsSupport.put(this.uri, 'application/json', content);
   },

   delete_ : function() {
      return rjsSupport.delete_(this.uri);
   }
}
