/*
* Support js for Profiles
*/

var useWrapProfiles = true;

function Profiles(uri_) {
    this.Profiles(uri_, false);
}

function Profiles(uri_, initialized_) {
    this.uri = uri_;
    this.profileId = '';
    this.username = '';
    this.category = '';
    this.type = '';
    this.minPrice = '';
    this.maxPrice = '';

    this.initialized = initialized_;
}

Profiles.prototype = {

   getUri : function() {
      return this.uri;
   },

   getProfileId : function() {
      if(!this.initialized)
         this.init();
      return this.profileId;
   },

   setProfileId : function(profileId_) {
      this.profileId = profileId_;
   },

   getUsername : function() {
      if(!this.initialized)
         this.init();
      return this.username;
   },

   setUsername : function(username_) {
      this.username = username_;
   },

   getCategory : function() {
      if(!this.initialized)
         this.init();
      return this.category;
   },

   setCategory : function(category_) {
      this.category = category_;
   },

   getType : function() {
      if(!this.initialized)
         this.init();
      return this.type;
   },

   setType : function(type_) {
      this.type = type_;
   },

   getMinPrice : function() {
      if(!this.initialized)
         this.init();
      return this.minPrice;
   },

   setMinPrice : function(minPrice_) {
      this.minPrice = minPrice_;
   },

   getMaxPrice : function() {
      if(!this.initialized)
         this.init();
      return this.maxPrice;
   },

   setMaxPrice : function(maxPrice_) {
      this.maxPrice = maxPrice_;
   },



   init : function() {
      var remote = new ProfilesRemote(this.uri);
      var c = remote.getJson_();
      if(c != -1) {
         var myObj = eval('(' +c+')');
         var profiles = myObj.profiles;
         if(profiles == null || profiles == undefined || profiles['@uri'] == undefined) {
            profiles = myObj;
            useWrapProfiles = false;
         }
         this.uri = profiles['@uri'];
         this.profileId = this.findValue(this.profileId, profiles['profileId']);
         this.username = this.findValue(this.username, profiles['username']);
         this.category = this.findValue(this.category, profiles['category']);
         this.type = this.findValue(this.type, profiles['type']);
         this.minPrice = this.findValue(this.minPrice, profiles['minPrice']);
         this.maxPrice = this.findValue(this.maxPrice, profiles['maxPrice']);

         this.initialized = true;
      }
   },

   findValue : function(field, value) {
      if(value == undefined)
          return field;
      else
         return value;
   },

   flush : function() {
      var remote = new ProfilesRemote(this.uri);
      if(useWrapProfiles)
         return remote.putJson_('{'+this.toString()+'}');
      else
         return remote.putJson_(this.toString());
   },

   delete_ : function() {
      var remote = new ProfilesRemote(this.uri);
      return remote.deleteJson_();
   },

   toString : function() {
      if(!this.initialized)
         this.init();
      var myObj = 
         '{'+
         '"@uri":"'+this.uri+'"'+
                  ', "profileId":"'+this.profileId+'"'+
         ', "username":"'+this.username+'"'+
         ', "category":"'+this.category+'"'+
         ', "type":"'+this.type+'"'+
         ', "minPrice":"'+this.minPrice+'"'+
         ', "maxPrice":"'+this.maxPrice+'"'+

         '}';
      if(useWrapProfiles) {
          myObj = '"profiles":'+myObj;
      }
      return myObj;
   },

   getFields : function() {
      var fields = [];
         fields.push('profileId');
         fields.push('username');
         fields.push('category');
         fields.push('type');
         fields.push('minPrice');
         fields.push('maxPrice');

      return fields;
   }

}

function ProfilesRemote(uri_) {
    this.uri = uri_+'?expandLevel=1';
}

ProfilesRemote.prototype = {

/* Default getJson_() method used by init() method. Do not remove. */
   getJson_ : function() {
      return rjsSupport.get(this.uri, 'application/json');
   },
/* Default putJson_() method used by flush() method. Do not remove. */
   putJson_ : function(content) {
      return rjsSupport.put(this.uri, 'application/json', content);
   },
/* Default deleteJson_() method used by delete_() method. Do not remove. */
   deleteJson_ : function() {
      return rjsSupport.delete_(this.uri);
   }
   ,
   getXml : function() {
      return rjsSupport.get(this.uri, 'application/xml');
   },

   getJson : function() {
      return rjsSupport.get(this.uri, 'application/json');
   },

   putXml : function(content) {
      return rjsSupport.put(this.uri, 'application/xml', content);
   },

   putJson : function(content) {
      return rjsSupport.put(this.uri, 'application/json', content);
   },

   delete_ : function() {
      return rjsSupport.delete_(this.uri);
   }
}
