/*
* Support js for Profiless
*/

var useWrapProfiless = true;

function Profiless(uri_) {
    this.uri = uri_;
    this.items = new Array();
    this.initialized = false;
}

Profiless.prototype = {

   getUri : function() {
      return this.uri;
   },

   getItems : function() {
      if(!this.initialized)
          this.init();
      return this.items;
   },

   addItem : function(item) {
      this.items.push(item);
   },

   removeItem : function(item) {
      var status = item.delete_();
      if(status)
        this.init(); //re-read items
      return status;
   },

   init : function() {
      var remote = new ProfilessRemote(this.uri);
      var c = remote.getJson_();
      if(c != -1) {
         var myObj = eval('('+c+')');
         var profiless = myObj.profiless;
         if(profiless == null || profiless == undefined || profiless['@uri'] == undefined) {
            profiless = myObj;
            useWrapProfiless = false;
         }
         this.items = new Array();
         var refs = profiless.profiles;
         if(refs != undefined) {
             if(refs.length == undefined) {
                 this.initChild(refs, 0);
             } else {
                 var j = 0;
                 for(j=0;j<refs.length;j++) {
                    var ref = refs[j];
                    this.initChild(ref, j);
                 }
             }
         } else {
            rjsSupport.debug('profiles is undefined, so skipping initChild for Profiless');
         }
         this.initialized = true;
      }
   },

   initChild : function(ref, j) {
      var uri2 = ref['@uri'];
      this.items[j] = new Profiles(uri2);
   },

   flush : function() {
      var remote = new ProfilessRemote(this.uri);
      if(useWrapProfiless)
         remote.postJson_('{'+this.toString()+'}');
      else
         return remote.postJson_(this.toString());
   },

   flush : function(profiles) {
      var remote = new ProfilessRemote(this.uri);
      if(useWrapProfiless)
         return remote.postJson_('{'+profiles.toString()+'}');
      else
         return remote.postJson_(profiles.toString());
   },

   toString : function() {
      if(!this.initialized)
         this.init();
      var s = '';
      var j = 0;
      if(this.items.length > 1)
          s = s + '[';
      for(j=0;j<this.items.length;j++) {
         var c = this.items[j];
         if(j<this.items.length-1)
            s = s + '{"@uri":"'+c.getUri()+'", "profilesId":"'+rjsSupport.findIdFromUrl(c.getUri())+'"},';
         else
            s = s + '{"@uri":"'+c.getUri()+'", "profilesId":"'+rjsSupport.findIdFromUrl(c.getUri())+'"}';
      }
      if(this.items.length > 1)
          s = s + ']';
      var myObj = '';
      if(s == '') {
          myObj = '{"@uri":"'+this.getUri()+'"}';
      } else {
          myObj = 
            '{'+'"@uri":"'+this.getUri()+'",'+'"profiles":'+s+''+'}';
      }
      if(useWrapProfiless) {
          myObj = '"profiless":'+myObj;
      }
      return myObj;
   }

}

function ProfilessRemote(uri_) {
    this.uri = uri_+'?expandLevel=0&start=0&max=50';
}

ProfilessRemote.prototype = {

/* Default getJson_() method used by init() method. Do not remove. */
   getJson_ : function() {
      return rjsSupport.get(this.uri, 'application/json');
   },
/* Default postJson_() method used by flush() methods. Do not remove. */
   postJson_ : function(content) {
      return rjsSupport.post(this.uri, 'application/json', content);
   }
   ,
   getXml : function() {
      return rjsSupport.get(this.uri, 'application/xml');
   },

   getJson : function() {
      return rjsSupport.get(this.uri, 'application/json');
   },

   postXml : function(content) {
      return rjsSupport.post(this.uri, 'application/xml', content);
   },

   postJson : function(content) {
      return rjsSupport.post(this.uri, 'application/json', content);
   },

   getProfilesResource : function(profileId) {
      var link = new Profiles(this.uri+'/'+profileId);
      return link;
   }
}
