/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package converter;

import java.net.URI;
import profile.Profiles;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlAttribute;
import javax.ws.rs.core.UriBuilder;
import javax.persistence.EntityManager;

/**
 *
 * @author pico
 */

@XmlRootElement(name = "profiles")
public class ProfilesConverter {
    private Profiles entity;
    private URI uri;
    private int expandLevel;
  
    /** Creates a new instance of ProfilesConverter */
    public ProfilesConverter() {
        entity = new Profiles();
    }

    /**
     * Creates a new instance of ProfilesConverter.
     *
     * @param entity associated entity
     * @param uri associated uri
     * @param expandLevel indicates the number of levels the entity graph should be expanded@param isUriExtendable indicates whether the uri can be extended
     */
    public ProfilesConverter(Profiles entity, URI uri, int expandLevel, boolean isUriExtendable) {
        this.entity = entity;
        this.uri = (isUriExtendable) ? UriBuilder.fromUri(uri).path(entity.getProfileId() + "/").build() : uri;
        this.expandLevel = expandLevel;
    }

    /**
     * Creates a new instance of ProfilesConverter.
     *
     * @param entity associated entity
     * @param uri associated uri
     * @param expandLevel indicates the number of levels the entity graph should be expanded
     */
    public ProfilesConverter(Profiles entity, URI uri, int expandLevel) {
        this(entity, uri, expandLevel, false);
    }

    /**
     * Getter for profileId.
     *
     * @return value for profileId
     */
    @XmlElement
    public Integer getProfileId() {
        return (expandLevel > 0) ? entity.getProfileId() : null;
    }

    /**
     * Setter for profileId.
     *
     * @param value the value to set
     */
    public void setProfileId(Integer value) {
        entity.setProfileId(value);
    }

    /**
     * Getter for username.
     *
     * @return value for username
     */
    @XmlElement
    public String getUsername() {
        return (expandLevel > 0) ? entity.getUsername() : null;
    }

    /**
     * Setter for username.
     *
     * @param value the value to set
     */
    public void setUsername(String value) {
        entity.setUsername(value);
    }

    /**
     * Getter for category.
     *
     * @return value for category
     */
    @XmlElement
    public String getCategory() {
        return (expandLevel > 0) ? entity.getCategory() : null;
    }

    /**
     * Setter for category.
     *
     * @param value the value to set
     */
    public void setCategory(String value) {
        entity.setCategory(value);
    }

    /**
     * Getter for type.
     *
     * @return value for type
     */
    @XmlElement
    public String getType() {
        return (expandLevel > 0) ? entity.getType() : null;
    }

    /**
     * Setter for type.
     *
     * @param value the value to set
     */
    public void setType(String value) {
        entity.setType(value);
    }

    /**
     * Getter for minPrice.
     *
     * @return value for minPrice
     */
    @XmlElement
    public Integer getMinPrice() {
        return (expandLevel > 0) ? entity.getMinPrice() : null;
    }

    /**
     * Setter for minPrice.
     *
     * @param value the value to set
     */
    public void setMinPrice(Integer value) {
        entity.setMinPrice(value);
    }

    /**
     * Getter for maxPrice.
     *
     * @return value for maxPrice
     */
    @XmlElement
    public Integer getMaxPrice() {
        return (expandLevel > 0) ? entity.getMaxPrice() : null;
    }

    /**
     * Setter for maxPrice.
     *
     * @param value the value to set
     */
    public void setMaxPrice(Integer value) {
        entity.setMaxPrice(value);
    }

    /**
     * Returns the URI associated with this converter.
     *
     * @return the uri
     */
    @XmlAttribute
    public URI getUri() {
        return uri;
    }

    /**
     * Sets the URI for this reference converter.
     *
     */
    public void setUri(URI uri) {
        this.uri = uri;
    }

    /**
     * Returns the Profiles entity.
     *
     * @return an entity
     */
    @XmlTransient
    public Profiles getEntity() {
        if (entity.getProfileId() == null) {
            ProfilesConverter converter = UriResolver.getInstance().resolve(ProfilesConverter.class, uri);
            if (converter != null) {
                entity = converter.getEntity();
            }
        }
        return entity;
    }

    /**
     * Returns the resolved Profiles entity.
     *
     * @return an resolved entity
     */
    public Profiles resolveEntity(EntityManager em) {
        return entity;
    }
}
