/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package converter;

import java.net.URI;
import java.util.Collection;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlAttribute;
import java.util.ArrayList;
import profile.Profiles;

/**
 *
 * @author pico
 */

@XmlRootElement(name = "profiless")
public class ProfilessConverter {
    private Collection<Profiles> entities;
    private Collection<ProfilesConverter> items;
    private URI uri;
    private int expandLevel;
  
    /** Creates a new instance of ProfilessConverter */
    public ProfilessConverter() {
    }

    /**
     * Creates a new instance of ProfilessConverter.
     *
     * @param entities associated entities
     * @param uri associated uri
     * @param expandLevel indicates the number of levels the entity graph should be expanded
     */
    public ProfilessConverter(Collection<Profiles> entities, URI uri, int expandLevel) {
        this.entities = entities;
        this.uri = uri;
        this.expandLevel = expandLevel;
        getProfiles();
    }

    /**
     * Returns a collection of ProfilesConverter.
     *
     * @return a collection of ProfilesConverter
     */
    @XmlElement
    public Collection<ProfilesConverter> getProfiles() {
        if (items == null) {
            items = new ArrayList<ProfilesConverter>();
        }
        if (entities != null) {
            items.clear();
            for (Profiles entity : entities) {
                items.add(new ProfilesConverter(entity, uri, expandLevel, true));
            }
        }
        return items;
    }

    /**
     * Sets a collection of ProfilesConverter.
     *
     * @param a collection of ProfilesConverter to set
     */
    public void setProfiles(Collection<ProfilesConverter> items) {
        this.items = items;
    }

    /**
     * Returns the URI associated with this converter.
     *
     * @return the uri
     */
    @XmlAttribute
    public URI getUri() {
        return uri;
    }

    /**
     * Returns a collection Profiles entities.
     *
     * @return a collection of Profiles entities
     */
    @XmlTransient
    public Collection<Profiles> getEntities() {
        entities = new ArrayList<Profiles>();
        if (items != null) {
            for (ProfilesConverter item : items) {
                entities.add(item.getEntity());
            }
        }
        return entities;
    }
}
