/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package profile;

import java.io.Serializable;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;

/**
 *
 * @author pico
 */
@Entity
@Table(name = "profiles")
@NamedQueries({
    @NamedQuery(name = "Profiles.findAll", query = "SELECT p FROM Profiles p"),
    @NamedQuery(name = "Profiles.findByProfileId", query = "SELECT p FROM Profiles p WHERE p.profileId = :profileId"),
    @NamedQuery(name = "Profiles.findByUsername", query = "SELECT p FROM Profiles p WHERE p.username = :username"),
    @NamedQuery(name = "Profiles.findByCategory", query = "SELECT p FROM Profiles p WHERE p.category = :category"),
    @NamedQuery(name = "Profiles.findByType", query = "SELECT p FROM Profiles p WHERE p.type = :type"),
    @NamedQuery(name = "Profiles.findByMinPrice", query = "SELECT p FROM Profiles p WHERE p.minPrice = :minPrice"),
    @NamedQuery(name = "Profiles.findByMaxPrice", query = "SELECT p FROM Profiles p WHERE p.maxPrice = :maxPrice")})
public class Profiles implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "profileId")
    private Integer profileId;
    @Basic(optional = false)
    @Column(name = "username")
    private String username;
    @Basic(optional = false)
    @Column(name = "category")
    private String category;
    @Basic(optional = false)
    @Column(name = "type")
    private String type;
    @Basic(optional = false)
    @Column(name = "minPrice")
    private int minPrice;
    @Basic(optional = false)
    @Column(name = "maxPrice")
    private int maxPrice;

    public Profiles() {
    }

    public Profiles(Integer profileId) {
        this.profileId = profileId;
    }

    public Profiles(Integer profileId, String username, String category, String type, int minPrice, int maxPrice) {
        this.profileId = profileId;
        this.username = username;
        this.category = category;
        this.type = type;
        this.minPrice = minPrice;
        this.maxPrice = maxPrice;
    }

    public Integer getProfileId() {
        return profileId;
    }

    public void setProfileId(Integer profileId) {
        this.profileId = profileId;
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public String getCategory() {
        return category;
    }

    public void setCategory(String category) {
        this.category = category;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public int getMinPrice() {
        return minPrice;
    }

    public void setMinPrice(int minPrice) {
        this.minPrice = minPrice;
    }

    public int getMaxPrice() {
        return maxPrice;
    }

    public void setMaxPrice(int maxPrice) {
        this.maxPrice = maxPrice;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (profileId != null ? profileId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Profiles)) {
            return false;
        }
        Profiles other = (Profiles) object;
        if ((this.profileId == null && other.profileId != null) || (this.profileId != null && !this.profileId.equals(other.profileId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "profile.Profiles[profileId=" + profileId + "]";
    }

}
