/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package service;

import java.util.Collection;
import javax.ws.rs.Path;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Produces;
import javax.ws.rs.Consumes;
import javax.ws.rs.PathParam;
import javax.ws.rs.QueryParam;
import javax.ws.rs.DefaultValue;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.UriInfo;
import javax.persistence.EntityManager;
import converter.ProfilessConverter;
import converter.ProfilesConverter;
import javax.persistence.PersistenceContext;
import javax.ejb.Stateless;
import profile.Profiles;

/**
 *
 * @author pico
 */

@Path("/profiless/")
@Stateless
public class ProfilessResource {
    @javax.ejb.EJB
    private ProfilesResource profilesResource;
    @Context
    protected UriInfo uriInfo;
    @PersistenceContext(unitName = "adProfilePU")
    protected EntityManager em;
  
    /** Creates a new instance of ProfilessResource */
    public ProfilessResource() {
    }

    /**
     * Get method for retrieving a collection of Profiles instance in XML format.
     *
     * @return an instance of ProfilessConverter
     */
    @GET
    @Produces({"application/xml", "application/json"})
    public ProfilessConverter get(@QueryParam("start")
                                  @DefaultValue("0")
    int start, @QueryParam("max")
               @DefaultValue("10")
    int max, @QueryParam("expandLevel")
             @DefaultValue("1")
    int expandLevel, @QueryParam("query")
                     @DefaultValue("SELECT e FROM Profiles e")
    String query) {
        return new ProfilessConverter(getEntities(start, max, query), uriInfo.getAbsolutePath(), expandLevel);
    }

    /**
     * Post method for creating an instance of Profiles using XML as the input format.
     *
     * @param data an ProfilesConverter entity that is deserialized from an XML stream
     * @return an instance of ProfilesConverter
     */
    @POST
    @Consumes({"application/xml", "application/json"})
    public Response post(ProfilesConverter data) {
        Profiles entity = data.resolveEntity(em);
        createEntity(data.resolveEntity(em));
        return Response.created(uriInfo.getAbsolutePath().resolve(entity.getProfileId() + "/")).build();
    }

    /**
     * Returns a dynamic instance of ProfilesResource used for entity navigation.
     *
     * @return an instance of ProfilesResource
     */
    @Path("{profileId}/")
    public ProfilesResource getProfilesResource(@PathParam("profileId")
    Integer id) {
        profilesResource.setId(id);
        profilesResource.setEm(em);
        return profilesResource;
    }

    /**
     * Returns all the entities associated with this resource.
     *
     * @return a collection of Profiles instances
     */
    protected Collection<Profiles> getEntities(int start, int max, String query) {
        return em.createQuery(query).setFirstResult(start).setMaxResults(max).getResultList();
    }

    /**
     * Persist the given entity.
     *
     * @param entity the entity to persist
     */
    protected void createEntity(Profiles entity) {
        entity.setProfileId(null);
        em.persist(entity);
    }
}
